// ======================================================================
//
// MenuHorizontalSliderBar.h
// ~Chuck Karpiak
//
// copyright 1997 origin systems inc
//
// ======================================================================

#ifndef MENU_HORIZONTAL_SLIDER_H
#define MENU_HORIZONTAL_SLIDER_H

// ======================================================================

class    Bitmap;
#include "MenuElement.h"

// ======================================================================

class MenuHorizontalSliderBar : public MenuElement
{
protected:

	real   percentage;

	int    xOffset;
	int    eventNumber;
	int    sliderBarWidth;
	int    sliderBarXHotSpot;
	Bitmap *bitmap;
	bool   pressingLeftMouse;

private:

	MenuHorizontalSliderBar(void);
	MenuHorizontalSliderBar(const MenuHorizontalSliderBar &);
	MenuHorizontalSliderBar &operator =(const MenuHorizontalSliderBar &);

	void             calculatePercentage(int mouseX);
	void             calculateXOffset(void);
	void             clampXOffset(void);

public:

	MenuHorizontalSliderBar(MenuElement *newParent, int maxWidth, int maxHeight, Iff *iff=NULL);
	virtual ~MenuHorizontalSliderBar(void);

	void             load(Iff *iff);

	virtual IoResult event(IoEventStruct *event);
	virtual void     menuDraw(int x, int y) const;

	real             getPercentage(void) const;
	void             setPercentage(real newPercentage);
};

// ======================================================================

inline real MenuHorizontalSliderBar::getPercentage(void) const
{
	return percentage;
}

// ======================================================================

#endif
